using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace spring16_sem2_winudpchat
{
    //page 183, 184, 185
    public partial class Form1 : Form
    {
        //server
        UdpClient server = new UdpClient(5001);
        IPEndPoint rxpoint = new IPEndPoint(new IPAddress(0), 0);
        UdpClient client = new UdpClient(5000);
        IPEndPoint txpoint = new IPEndPoint(new IPAddress(0), 0);


        //add thread, allow us to write to the listbox
        delegate void SetTextCallBack(string text);

        //server code
        private void WaitForDataFromClient()
        {
            while (true)
            {
                //receive data from the server
                byte[] ClientData = server.Receive(ref rxpoint);

                //display on the listbox
                ListBoxDisplay("Server received : " + (System.Text.Encoding.ASCII.GetString(ClientData)));

                //and echo back
                ListBoxDisplay("Sending back");
                server.Send(ClientData, ClientData.Length, rxpoint);
            }
        }

        private void ListBoxDisplay(string message)
        {
            this.SetListBox(message);
        }

        private void SetListBox(string strText)
        {
            if(listBox1.InvokeRequired)
            {
                SetTextCallBack d = new SetTextCallBack(SetListBox);
                this.Invoke(d, new object[]{strText});
            }
            else
            {
                this.listBox1.Items.Add(strText);
            }
        }


        public Form1()
        {
            InitializeComponent();
            //start server
            Thread serverThread = new Thread(new ThreadStart(WaitForDataFromClient));
            serverThread.Start();
            Thread clientThread = new Thread(new ThreadStart(WaitForDataFromServer));
            clientThread.Start();
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                //create a string datagram packet
                string packet = textBox1.Text;
                //convert packet to array of bytes
                byte[] sendData = System.Text.Encoding.ASCII.GetBytes(packet);
                //send to server on port 5001
                this.client.Send(sendData, sendData.Length, "localhost", 5001);
                //clear textbox
                textBox1.Clear();
            }
        }

        private void WaitForDataFromServer()
        {
            while (true)
            {
                //receive data from client
                byte[] rxdata = client.Receive(ref this.txpoint);
                ListBoxDisplay("Client recieved : " + System.Text.Encoding.ASCII.GetString(rxdata));
            }
        }
    }
}